package cn.iocoder.yudao.module.member.api.memberUserScore;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.member.convert.memberUserScore.MemberUserScoreConvert;
import cn.iocoder.yudao.module.member.dal.dataobject.memberUserScore.MemberUserScoreDO;
import cn.iocoder.yudao.module.member.service.memberUserScore.MemberUserScoreService;
import cn.iocoder.yudao.module.member.vo.memberUserScore.MemberUserScoreBackVO;
import cn.iocoder.yudao.module.member.vo.memberUserScore.MemberUserScoreQueryVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Validated
@RestController
@Api(tags = "管理后台 - 会员积分")
@RequestMapping("/member/user-score")
public class MemberUserScoreController {

    @Resource
    private MemberUserScoreService userScoreService;

    @GetMapping("/page")
    @ApiOperation("获得会员积分分页")
    @PreAuthorize("@ss.hasPermission('member:user-score:query')")
    public CommonResult<PageResult<MemberUserScoreBackVO>> getUserScorePage(@Valid MemberUserScoreQueryVO query, PageVO page) {
        PageResult<MemberUserScoreBackVO> pageResult = userScoreService.getUserScorePage(query, page);
        return success(pageResult);
    }
}
