package cn.iocoder.yudao.module.member.dal.mysql.memberUserScore;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.member.dal.dataobject.memberUserScore.MemberUserScoreDO;
import cn.iocoder.yudao.module.member.vo.memberUserScore.MemberUserScoreQueryVO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 会员积分 Mapper
 * @author 系统管理员
 */
@Mapper
public interface MemberUserScoreMapper extends AbstractMapper<MemberUserScoreDO> {
    @Override
    default PageResult<MemberUserScoreDO> selectPage(PageVO page, Object object) {
        if (object instanceof MemberUserScoreQueryVO) {
            MemberUserScoreQueryVO vo = (MemberUserScoreQueryVO)object;
            return selectPage(page, new LambdaQuery<MemberUserScoreDO>()
                .eqIfPresent(MemberUserScoreDO::getMemberId, vo.getMemberId())
                .eqIfPresent(MemberUserScoreDO::getHoldScore, vo.getHoldScore())
                .eqIfPresent(MemberUserScoreDO::getUsedScore, vo.getUsedScore())
                .eqIfPresent(MemberUserScoreDO::getExpiredScore, vo.getExpiredScore())
                .betweenIfPresent(MemberUserScoreDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(MemberUserScoreDO::getId));
        }

        return null;
    }

    @Override
    default List<MemberUserScoreDO> selectList(Object object) {
        if (object instanceof MemberUserScoreQueryVO) {
            MemberUserScoreQueryVO vo = (MemberUserScoreQueryVO)object;
            return selectList(new LambdaQuery<MemberUserScoreDO>()
                .eqIfPresent(MemberUserScoreDO::getMemberId, vo.getMemberId())
                .eqIfPresent(MemberUserScoreDO::getHoldScore, vo.getHoldScore())
                .eqIfPresent(MemberUserScoreDO::getUsedScore, vo.getUsedScore())
                .eqIfPresent(MemberUserScoreDO::getExpiredScore, vo.getExpiredScore())
                .betweenIfPresent(MemberUserScoreDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(MemberUserScoreDO::getId));
        }

        return null;
    }
}
